#!/usr/bin/python
# -*- coding: ascii -*-
# $Id$
#
# Author:  Put your name here 
# Date:	 24/12/2018 
#        22/04/2020 suppression #MAXI_Z# , ajout PARAMETRE_P

__author__ = "Pierre Ley"
__email__  = "pinatl@hotmail.fr"  #<<< here put an email where plugins users can contact you

#Here import the libraries you need, these are necessary to modify the code 
# prendre le fichier template  "/bCNC/templates/palpage_Z.template"
#                         remplacer #POS_X# par  Pos_palp_X (position du palpeur en X)
#                         remplacer #POS_Y# par  Pos_palp_Y (position du palpeur en Y)
#                         remplacer #Pos_palp_Z# par  Pos_palp_Z (Z de la face supportant le palpeur)
#                         remplacer #PALP_Z# par  Long_palp + Pos_palp_Z (Z de declanchement du palpeur)
#                         remplacer #DECALAGE# par  G54, G55 ... ou G59
#                         remplacer #PARAMETRE_P# par  1 si on est en G54, 2 si on est en G55 ... jusqu'a G59 uniquement. G59.1, G59.2 et G59.3 ne sont pas pris en compte
import threading,time,os
from CNC import CNC,Block
from ToolsPage import Plugin
def cherche_keyword (line):
	retour = 0
	
	if ( '#POS_X#' in line ) :
		retour = 1
	if ( '#POS_Y#' in line ) :
		retour = 2	
	if ( '#POS_Z#' in line ) :
		retour = 3
	if ( '#PALP_Z#' in line ) :
		retour = 4	
	if ( '#DECALAGE#' in line ) :
		retour = 5	
	if ( '#PARAMETRE_P#' in line ) :
		retour = 6			
	return retour
	
def remplace (keyword,line,Pos_palp_X,Pos_palp_Y,Pos_palp_Z,Long_palp,decalage,PARAMETRE_P):

	if ( keyword == 1 ):
		index = line.find('#POS_X#')
		nb_car_remplace=7
		char_remplace=str(Pos_palp_X)
	if ( keyword == 2 ):
		index = line.find('#POS_Y#')
		nb_car_remplace=7
		char_remplace=str(Pos_palp_Y)
	if ( keyword == 3 ):
		index = line.find('#POS_Z#')
		nb_car_remplace=7
		char_remplace=str(Pos_palp_Z)
	if ( keyword == 4 ):
		index = line.find('#PALP_Z#')
		nb_car_remplace=8
		char_remplace=str(Long_palp + Pos_palp_Z)
	if ( keyword == 5 ):
		index = line.find('#DECALAGE#')
		nb_car_remplace=10
		char_remplace=str(decalage)
	if ( keyword == 6 ):
		index = line.find('#PARAMETRE_P#')
		nb_car_remplace=13
		char_remplace=str(PARAMETRE_P)
		
	nbcar = len(line)
	line_modifiee=line.__getslice__(0,index)	+ char_remplace
	if (index + nb_car_remplace < nbcar ):
		line_modifiee = line_modifiee + line.__getslice__(index+nb_car_remplace,nbcar)
	
	return line_modifiee
	
def get_template():

	dirpath = os.getcwd()
	if ( '/' in dirpath ) :
		# on est sous UNIX
		fichier_template = dirpath + "/bCNC/templates/palpage_Z.template"
	else:
		# on est sous windows
		fichier_template = dirpath + "\\bCNC\\templates\\palpage_Z.template"
	
	return fichier_template
		
#==============================================================================
# My plugin
#==============================================================================
class Tool(Plugin):
	# WARNING the __doc__ is needed to allow the string to be internationalized
	__doc__ = _("""palpeur_Z""")			#<<< This comment will be show as tooltip for the ribbon button
	def __init__(self, master):
		Plugin.__init__(self, master,"palpeur_Z")
		#MYPlugin: is the name of the plugin show in the tool ribbon button
		self.icon = "palpeur_Z"			#<<< This is the name of gif file used as icon for the ribbon button. It will be search in the "icons" subfolder
		self.group = "CAM"	#<<< This is the name of group that plugin belongs
		#Here we are creating the widgets presented to the user inside the plugin
		#Name, Type , Default value, Description
		self.variables = [			#<<< Define a list of components for the GUI
			("Decalage"   , "int" ,    54, _("Decalage (54, 55, 56, 57, 58, ou 59")),			#G54, G55, G56, G57, G58 ou G59
			("Palpeur_X"   , "float" ,    0.0, _("Position palpeur en X")),			#position en X du palpeur
			("Palpeur_Y"   , "float" ,    0.0, _("Position palpeur en Y")),			#position en Y du palpeur
			("Palpeur_Z"   , "float" ,    15.0, _("Z de la face supportant le palpeur")),			#position en Z du palpeur	
			("Longueur_palp", "float",  20.0, _("Hauteur du palpeur"))			#lHauteur du palpeur	
		]
		self.buttons.append("exe")  #<<< This is the button added at bottom to call the execute method below

	# ----------------------------------------------------------------------
	# This method is executed when user presses the plugin execute button 
	# ----------------------------------------------------------------------
		
	def execute(self, app):
		#name = self["name"]
		#if not name or name=="default": name="Default Name"

		#Retrive data from user imput
		decalage = self["Decalage"]
		Pos_palp_X = self["Palpeur_X"]
		Pos_palp_Y = self["Palpeur_Y"]
		PARAMETRE_P = decalage - 53
		Pos_palp_Z = self["Palpeur_Z"]
		Long_palp = self["Longueur_palp"]
		
		#Initialize blocks that will contain our gCode
		name="palpeur_Z"
		blocks = []
		block = Block(name)
		
		# lecture du fichier template
		#
		fichier_template = get_template()
		#
		#   lecture du fichier
		#
		fo = open(fichier_template,'r')
		#
		all_line = fo.read();
		# Close opend file
		fo.close()
		#		
		longueur_file = len(all_line) - 1
		#
		continue_loop = True
		compteur_car = 0
		line_lu = ""
		#
		#   on recherche toutes les lignes de code du fichier template
		#
		while continue_loop == True:
			valeur_ascii = ord(all_line[compteur_car])   #ord() donne la valeur ascii du caractere, chr(97) donne le caractere dont la valeur ascii est 97
			if ( valeur_ascii == 10 ) :
				keyword=1
				while (keyword > 0):
				
					keyword=cherche_keyword(line_lu)
				
					if ( keyword <> 0 ):
						line_lu=remplace(keyword,line_lu,Pos_palp_X,Pos_palp_Y,Pos_palp_Z,Long_palp,decalage,PARAMETRE_P)
					else:
						block.append(line_lu)
						line_lu = ""
			else:
				line_lu = line_lu + all_line[compteur_car]
				
			compteur_car = compteur_car + 1
			if (compteur_car > longueur_file ) : 
				continue_loop = False
				if (len (line_lu) >1):
					block.append(line_lu)
					line_lu = ""
		#	
		#use some useful bCNC functions to generate gCode movement, see CNC.py for more
		# x = 0
		# y = 0
		# block.append(CNC.zsafe()) 			#<<< Move rapid Z axis to the safe height in Stock Material
		# block.append(CNC.grapid(x,y))		#<<< Move rapid to X and Y coordinate
		# block.append(CNC.zenter(-1)) 		#<<< Enter in the material with Plunge Feed for current material
		# cutFeed = CNC.vars["cutfeed"]		#<<< Get cut feed for the current material
		# block.append(CNC.fmt("f",cutFeed))	#<<< Set cut feed
		#
		#Add interpolated line to varius x,y coordinates
		# i = Pos_palp_X / 20.0
		# while (x < Pos_palp_X):
		# 	x += i
		# 	block.append(CNC.gline(x,0))
		# 	block.append(CNC.gline(0,Pos_palp_X - y))
		# 	y += i
		# 	block.append(CNC.gline(0,Pos_palp_X - y))
		# 
		#
		blocks.append(block)
		active = app.activeBlock()
		app.gcode.insBlocks(active, blocks, "MyPlugins inserted")	#<<< insert blocks over active block in the editor
		app.refresh()												#<<< refresh editor
		app.setStatus(_("Palpage en Z prepare"))				#<<< feed back result
